<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.assertion-manager.ModelBasedValidationServices']}</h1>
        <h:panelGroup rendered="#{identity.loggedIn}">
            <h:form id="globalform">
                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                    <s:token allowMultiplePosts="true"/>
                    <ui:define name="panel_title">Model based validation services</ui:define>
                    <rich:dataTable rows="20" id="mbvService" var="mbvService"
                                    value="#{mbvServiceManager.getMbvServices()}" render="ds">
                        <g:column id="keyword">
                            <ui:define
                                    name="header">#{messages['net.ihe.gazelle.assertion-manager.Keyword']}</ui:define>
                            <h:outputText value="#{mbvService.keyword}"/>
                        </g:column>
                        <g:column id="url">
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.Url']}</ui:define>
                            <h:outputText value="#{mbvService.url}"/>
                        </g:column>
                        <g:column id="coverage">
                            <ui:define name="header">##{messages['net.ihe.gazelle.assertion-manager.AssertionsCovered']}
                            </ui:define>
                            <h:outputText value="#{mbvService.assertionCount()}"/>
                        </g:column>
                        <g:column id="updateStatus">
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.UpdateStatus']}
                            </ui:define>
                            <h:outputText value="#{mbvService.updateStatus.getFriendlyName()}"/>
                            <h:outputText value="#{mbvService.getUpdateProgress()}"/>
                        </g:column>
                        <g:column id="lastUpdate">
                            <ui:define name="header">#{messages['net.ihe.gazelle.assertion-manager.LastUpdated']}
                            </ui:define>
                            <h:panelGroup rendered="#{!mbvService.hasNeverBeenUpdated()}">
                                <g:date tooltip="true" value="#{mbvService.lastUpdated}"/>
                            </h:panelGroup>
                            <h:panelGroup rendered="#{mbvService.hasNeverBeenUpdated()}">
                                <h:outputText value="Never updated"/>
                            </h:panelGroup>
                        </g:column>
                        <g:column id="actionColumn">
                            <ui:define name="header">
                                <h:outputText id="headerOutputText"
                                              value="#{messages['net.ihe.gazelle.Actions']}"/>
                            </ui:define>
                            <h:outputLink title="#{messages['net.ihe.gazelle.assertion-manager.ViewCoverageDetails']}"
                                          value="#{request.contextPath}/mbvServices/coverageStatus.seam">
                                <f:param name="id" value="#{mbvService.id}"/>
                                <span class="gzl-icon-search"/>
                            </h:outputLink>

                            <a4j:commandLink id="refreshSupport"
                                             title="#{messages['net.ihe.gazelle.assertion-manager.RefreshCoverage']}"
                                             onsubmit="jq162('#panelLoading').modal('show');"
                                             oncomplete="#{rich:component('panelLoading')}.hide();"
                                             action="#{mbvServiceManager.refreshCoverageOf(mbvService.id)}"
                                             render="globalform" execute="@this">
                                <span class="gzl-icon-refresh"/>
                            </a4j:commandLink>

                            <a4j:commandLink id="mbvServiceEditSupport" title="#{messages['users.Edit']}"
                                             actionListener="#{mbvServiceManager.edit(mbvService)}"
                                             render="globalform" execute="@this">
                                <span class="gzl-icon-pencil"/>
                            </a4j:commandLink>
                            <a4j:commandLink event="click"
                                             rendered="#{s:hasRole('admin_role')}"
                                             title="#{messages['users.Delete']}"
                                             oncomplete="jq162('#DeleteConfirmationModalPanel').modal('show');"
                                             render="deleteMbvServiceForm,globalform"
                                             actionListener="#{mbvServiceManager.setSelectedMbvService(mbvService)}">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>

                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="mbvService"/>
                                <ui:param name="hideRowsSelect" value="true"/>
                                <ui:param name="maxPages" value="5"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                    <h:panelGroup rendered="#{mbvServiceManager.showEditPanel}">
                        <div class="row">
                            <div class="col-lg-6 col-lg-offset-3">
                                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                                    <ui:define name="panel_title">
                                        #{messages['net.ihe.gazelle.assertion-manager.EditMBVService']}
                                    </ui:define>

                                    <s:decorate id="keywordDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Keyword']}
                                        </ui:define>
                                        <ui:param name="id" value="mbvKey"/>
                                        <h:inputText id="mbvKey" styleClass="form-control"
                                                     value="#{mbvServiceManager.selectedMbvService.keyword}"
                                                     required="true">
                                            <a4j:ajax event="blur" render="keywordDecoration" execute="@this"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <s:decorate id="urlDecoration" template="/layout/form/_edit.xhtml">
                                        <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Url_2']}
                                        </ui:define>
                                        <ui:param name="id" value="urlField"/>
                                        <h:inputText id="urlField" size="100" styleClass="form-control"
                                                     value="#{mbvServiceManager.selectedMbvService.url}"
                                                     required="true">
                                            <f:validator binding="#{uriValidator}"/>
                                            <a4j:ajax event="blur" render="urlDecoration" execute="@this"/>
                                        </h:inputText>
                                    </s:decorate>
                                    <ui:define name="panel_footer">
                                        <a4j:commandButton
                                                value="#{messages['net.ihe.gazelle.assertion-manager.SaveThisService']}"
                                                id="add" actionListener="#{mbvServiceManager.save()}"
                                                styleClass="gzl-btn-green"
                                                rendered="#{mbvServiceManager.selectedMbvService.id == null}"
                                                render="globalform"/>
                                        <a4j:commandButton
                                                value="#{messages['net.ihe.gazelle.assertion-manager.UpdateThisMbvService']}"
                                                actionListener="#{mbvServiceManager.save()}"
                                                styleClass="gzl-btn-orange" id="update"
                                                rendered="#{mbvServiceManager.selectedMbvService.id != null}"
                                                render="globalform"/>

                                        <a4j:commandButton styleClass="gzl-btn" id="cancel"
                                                           value="#{messages['users.Cancel']}"
                                                           actionListener="#{mbvServiceManager.cancel()}"
                                                           render="globalform"
                                                           execute="@this"/>
                                    </ui:define>
                                </ui:decorate>
                            </div>
                        </div>
                    </h:panelGroup>
                    <h:panelGroup rendered="#{mbvServiceManager.getScheduledJobs().size() != 0}">
                        <h3>Running updates (background)</h3>
                        <rich:dataTable rows="20" id="jobs" var="job"
                                        value="#{mbvServiceManager.getScheduledJobs()}">

                            <g:column sortOrder="ascending">
                                <ui:define name="header">Job</ui:define>
                                #{job.getName()}
                            </g:column>
                            <g:column sortOrder="ascending">
                                <ui:define name="header">Start date</ui:define>
                                #{job.getStart()}
                            </g:column>
                        </rich:dataTable>
                    </h:panelGroup>
                    <ui:define name="panel_footer">
                        <a4j:commandButton
                                value="#{messages['net.ihe.gazelle.assertion-manager.AddNewMbvService']}"
                                id="addNewMbvService"
                                rendered="#{!mbvServiceManager.showEditPanel}"
                                actionListener="#{mbvServiceManager.newMbvService()}"
                                styleClass="gzl-btn-green" render="globalform"/>

                        <h:commandButton
                                value="Synchronize all"
                                rendered="#{!mbvServiceManager.showEditPanel}"
                                disabled="#{mbvServiceManager.getScheduledJobs().size() != 0}"
                                action="#{mbvServiceManager.refreshCoverages()}"
                                styleClass="gzl-btn"/></ui:define>
                </ui:decorate>
            </h:form>
        </h:panelGroup>

        <h:form id="deleteMbvServiceForm">
            <s:token allowMultiplePosts="true"/>
            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="DeleteConfirmationModalPanel"/>
                <ui:define name="popup_title">
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.assertion-manager.ConfirmDelete']}"/>
                </ui:define>
                <h:outputText id="currentMbvService_DeleteOutputText"
                              value="#{messages['net.ihe.gazelle.assertion-manager.DoYouReallyWantToDeleteThisScope']} #{mbvServiceManager.getSelectedMbvService().getKeyword()}?"/>

                <ui:define name="popup_footer">
                    <h:commandButton value="#{messages['users.Cancel']}"
                                     styleClass="gzl-btn"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>
                    <h:commandButton value="#{messages['users.Delete']}" action="#{mbvServiceManager.delete()}"
                                     styleClass="gzl-btn-red" render="globalform"
                                     onclick="jq162('#DeleteConfirmationModalPanel').modal('hide');"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
